#!/bin/sh

# We need to do a lot of stuff like mount, mknod, and creating a symlink in
# the top level directory, which would ordinarily require root access.  But
# we can do all of this as a normal user by running User Mode Linux and doing
# the rest of the build in a virtual environment (within which we have root
# access).

cd tmpdir &&
echo "=== Build tiny init substitute" &&
gcc -Os -s ../sources/system/outit.c -o outit &&
echo "=== Build UML (with squashfs support)" &&
tar xvjf ../sources/system/linux-2.6.13.2.tar.bz2 &&
cd linux-2.6.13.2 &&
cat ../../sources/system/linux-*patch | patch -p1 &&
tar xvzf ../../sources/system/squashfs2.2-r2.tar.gz &&
cat squashfs2.2-r2/linux-2.6.13/squashfs2.2-patch | patch -p1 &&
rm -rf squashfs2.2-r2 &&
cat >> .config << EOF &&
CONFIG_MODE_SKAS=y
CONFIG_BINFMT_ELF=y
CONFIG_HOSTFS=y
CONFIG_SYSCTL=y
CONFIG_STDERR_CONSOLE=y
CONFIG_UNIX98_PTYS=y
CONFIG_BLK_DEV_LOOP=y
CONFIG_BLK_DEV_UBD=y
CONFIG_SWAP=y
#CONFIG_INITRAMFS_SOURCE="initramfs/initramfs.txt"
CONFIG_LBD=y
CONFIG_EXT2_FS=y
CONFIG_PROC_FS=y
CONFIG_SQUASHFS=y
CONFIG_SQUASHFS_FRAGMENT_CACHE_SIZE=3
CONFIG_ZLIB_INFLATE=y
EOF
yes "" | make ARCH=um oldconfig &&
make ARCH=um &&
mv linux .. &&
cd .. &&
rm -rf linux-2.6.13.2

if [ $? -ne 0 ]; then exit 1; fi
