#!/bin/sh

export LC_ALL=POSIX
unset CFLAGS CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
DIR=`pwd`

. "$DIR"/sources/scripts/runuml.sh

echo "=== Phase 1: cross-compile a uClibc based toolchain."

# This script is run within a UML instance in order to build a /tools directory
# as described in Linux From Scratch V5.0 (www.linuxfromscratch.org).

# /tools provides a self-contained compiler that can build simple software
# packages even on an otherwise empty system.  This provides us with a known
# environment with which to build the final system, one which can be removed
# by deleting a single directory.

# We're using uClibc instead of glibc, we've replaced most of the gnu packages
# with busybox, and we package the result in a squashfs image.

# We wrap the tools build in User Mode Linux.  The UML init script sets up the
# environment so the build script thinks it has a normal linux environment to
# work with.

export UMLSETUP=sources/scripts/1.0-tools-umlsetup.sh

runuml sources/scripts/1.1-tools-build.sh

if [ -f tmpdir/finished ]
then
  rm tmpdir/finished
  runuml sources/scripts/1.2-tools-package.sh
fi

if [ ! -f tmpdir/tools.img ]; then exit 1; fi
