#!/bin/sh

# This bit should be statically linked against uClibc...

cd tmpdir &&

# This should be linked against parent system's libraries

tar xvjf ../sources/system/linux-2.6.*.tar.bz2 &&
cd linux-2.6.* &&
tar xvzf ../../sources/system/squashfs2.2-r2.tar.gz &&
patch -p1 -i squashfs2.2-r2/linux-2.6.13/squashfs2.2-patch &&
mkdir initramfs &&
cat >> initramfs/initramfs.txt << EOF &&
dir /dev 755 0 0
nod /dev/console 644 0 0 c 5 1
nod /dev/loop0 600 0 0 b 7 0
dir /bin 755 1000 1000
slink /bin/sh busybox 777 0 0
slink /bin/[ busybox 777 0 0
slink /bin/awk busybox 777 0 0
slink /bin/chroot busybox 777 0 0
slink /bin/dd busybox 777 0 0
slink /bin/false busybox 777 0 0
slink /bin/head busybox 777 0 0
slink /bin/losetup busybox 777 0 0
slink /bin/mount busybox 777 0 0
slink /bin/od busybox 777 0 0
slink /bin/readlink busybox 777 0 0
slink /bin/test busybox 777 0 0
slink /bin/true busybox 777 0 0
dir /proc 755 0 0
dir /sub 755 0 0
file /init initramfs/init.sh 755 0 0
file /bin/busybox initramfs/busybox 755 0 0
EOF
cat >> initramfs/init.sh << 'EOF' &&
#!/bin/sh

# Find the UML executable in the parent filesystem
mount -n -t proc /proc /proc
mount -n -t hostfs -o / /sub /sub 2>/dev/null
if [ $? -eq 0 ]
then
  i=/sub`readlink /sub/proc/self/exe`
else
  echo "Implement this!"
  # For a bootable linux kernel, use /sys to find /dev/hda1/path/to/vmlinuz
fi
# Find offset of squashfs image.
len=`dd if=$i skip=12 bs=1 count=4 2> /dev/null | od -l | head -n 1 | awk '{print $2}'`
# loopback mount it
losetup -o $len /dev/loop0 $i
mount -n -t squashfs -o ro /dev/loop0 /dev
unset i len
cd dev
# Need switch_root here to free memory from rootfs
mount --move /dev /
exec chroot . /bin/sh
EOF
cp ../initramfs-busybox initramfs/busybox &&
make ARCH=um allnoconfig &&
cat >> .config << EOF &&
CONFIG_MODE_SKAS=y
CONFIG_BINFMT_ELF=y
CONFIG_HOSTFS=y
CONFIG_SYSCTL=y
CONFIG_STDERR_CONSOLE=y
CONFIG_UNIX98_PTYS=y
CONFIG_BLK_DEV_LOOP=y
CONFIG_INITRAMFS_SOURCE="initramfs/initramfs.txt"
CONFIG_LBD=y
CONFIG_EXT2_FS=y
CONFIG_PROC_FS=y
CONFIG_SQUASHFS=y
CONFIG_SQUASHFS_FRAGMENT_CACHE_SIZE=3
CONFIG_ZLIB_INFLATE=y
EOF
yes "" | make ARCH=um oldconfig &&
make ARCH=um &&
strip linux -o ../../firmware-uml &&
cd .. &&
rm -rf linux-2.6*

if [ $? -ne 0 ]; then exit 1; fi

gcc -s -Os ../sources/buildtools/marksize.c -o marksize &&
cd .. &&
# Create standalone runnable User Mode Linux version of firmware.
tmpdir/marksize firmware-uml &&
cat tmpdir/build.sqf >> firmware-uml
